  ; 21/06/2006 
  ; PB Version 4.0 update
  ; Finally got around to updating for PB V4
  
  ; 02/12/2005
  ; Updated from original DeMusic Lib to DeMp3 Lib by Baldrick
  ; Deleted DeMp3SetVolBal() command in preference to setting volume & balance independently
  ; Modified DeMp3SetBalance() to use values left bias -1000 through +1000 right bias
  ; so it now matches Mp3GetBalance() returns of -1000 to +1000. 
  ;
  ; 17/11/2005
  ; This Lib written by Baldrick
  ; PB Version: 3.94
  ; This lib done as an exersize for myself in lib making using El Choni's TailBite
  ; inspired pretty much from a post in the English forum by CGI on mcisendstring()
  
;{ DeMp3GetStatus (Start)
ProcedureDLL.s DeMp3GetStatus(TrackNum) ;Get current status of loaded file. e.g "playing", "stopped"
Track$=Str(TrackNum) 
  status$=Space(32)
  sent=mciSendString_("status TrackNo:"+Track$+" mode",@status$,32,NULL) 
  ProcedureReturn status$
  EndProcedure
;} DeMp3GetStatus (End)

;{ DeMp3Load Start
ProcedureDLL DeMp3Load(TrackNum,File.s) ; Load a music file ready to play
Track$=Str(TrackNum) 
  qm.s=Chr(34)
  sent=mciSendString_("open "+qm+File+qm+" alias TrackNo:"+Track$,NULL,NULL,NULL) 
  If sent=0  
    send=mciSendString_("set TrackNo:"+Track$+" time format ms",NULL,NULL,NULL)
  Else 
  EndIf 
    ProcedureReturn sent
EndProcedure
;} DeMp3Load End

;{ DeMp3Play Start
ProcedureDLL DeMp3Play(TrackNum) ; start playing the song preiviously loaded with DeMusicLoad(TrackNum)
Track$=Str(TrackNum)
  sent=mciSendString_("play TrackNo:"+Track$,NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3Play End

;{ DeMp3PlayStart Start
ProcedureDLL DeMp3PlayStart(TrackNum) ; same as DeMusicPlay() 
Track$=Str(TrackNum)
  sent=mciSendString_("play TrackNo:"+Track$+" from 0",NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure 
;} DeMp3PlayStart End

;{ DeMp3PlayPart start
ProcedureDLL DeMp3PlayPart(TrackNum,Start,endPos); Play a section of loaded music
Track$=Str(TrackNum) 
  sent=mciSendString_("play TrackNo:"+Track$+" from "+Str(Start)+" To "+Str(endPos),NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure 
;} DeMp3PlayPart End

;{ DeMp3Pause Start
ProcedureDLL DeMp3Pause(TrackNum); pause the currently playing music
Track$=Str(TrackNum) 
  sent=mciSendString_("pause TrackNo:"+Track$,NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3Pause End

;{ DeMp3Resume Start
ProcedureDLL DeMp3Resume(TrackNum) ; resume the current music from point where paused
Track$=Str(TrackNum) 
  sent=mciSendString_("resume TrackNo:"+Track$,NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3Resume End

;{ DeMp3Stop Start
ProcedureDLL DeMp3Stop(TrackNum,Option) ; Options: 0= Stop and return to start of song, 1= Stop and remain at current position
Track$=Str(TrackNum)
If Option=1 
  sent=mciSendString_("stop TrackNo:"+Track$,NULL,NULL,NULL)
  EndIf
  If Option=0
  sent=mciSendString_("play TrackNo:"+Track$+" from 0 To 0",NULL,NULL,NULL)
  EndIf 
  ProcedureReturn sent 
EndProcedure
;} DeMp3Stop End

;{ DeMp3Free Start
ProcedureDLL DeMp3Close(TrackNum) ; Close the music previously loaded with DeMusicLoad & free it from memory
Track$=Str(TrackNum) 
  sent=mciSendString_("close TrackNo:"+Track$,NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3Free End
 
;{ DeMp3SetVolume Start
ProcedureDLL DeMp3SetVolume(TrackNum,volume); Set the volume for this music
Track$=Str(TrackNum) 
  sent=mciSendString_("SetAudio TrackNo:"+Track$+" volume To "+Str(volume),NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3SetVolume End

;{ DeMp3GetVolume Start
ProcedureDLL DeMp3GetVolume(TrackNum) ;Return the current volume for this music
Track$=Str(TrackNum) 
  Thismessage$=Space(32) 
  sent=mciSendString_("status TrackNo:"+Track$+" volume ",Thismessage$,32,NULL)
  Thismessage$=PeekS(@Thismessage$) 
  ProcedureReturn Val(Thismessage$) 
EndProcedure
;} DeMp3GetVolume End

 ;{ DeMp3SetBalance Start
 ProcedureDLL.s DeMp3SetBalance(TrackNum,Volume,Balance) ;Balance valid between -1000 and 1000 ; Volume between 0 and 1000 required as reference point
 Track$=Str(TrackNum)
 If Volume>1000
 Volume=1000
 EndIf
 If Volume<0
 Volume=0
 EndIf
 If Balance>1000
 Balance=1000
 EndIf
 If Balance<-1000
 Balance=-1000
 EndIf
 If Balance<=1000
 If Balance<=1000 And Balance>0
 Left=(1000-Balance)*Volume/1000
 Right=Volume
 EndIf
 If Balance<0
 Left=Volume
 Right=(Balance+1000)*Volume/1000
 EndIf
 EndIf
 If balance=0
 left=volume
 right=volume
 EndIf
  Rsent=mciSendString_("SetAudio TrackNo:"+Track$+" right volume To "+Str(Right),NULL,NULL,NULL)
  Lsent=mciSendString_("SetAudio TrackNo:"+Track$+" left volume To "+Str(Left),NULL,NULL,NULL) 
  sent$="L"+Str(Lsent)+"R"+Str(Rsent)
  ProcedureReturn sent$

 EndProcedure
;} DeMp3SetBalance End

 ;{ DeMp3GetBalance Start 
 ProcedureDLL DeMp3GetBalance(TrackNum) ; Get the current Balance of the music
Track$=Str(TrackNum) 
  Left$=Space(32) 
  Right$=Space(32)
  volume$=Space(32)
  sent=mciSendString_("status TrackNo:"+Track$+" volume",volume$,32,NULL)
  sent=mciSendString_("status TrackNo:"+Track$+" left volume",Left$,32,NULL)
  sent=mciSendString_("status TrackNo:"+Track$+" right volume",Right$,32,NULL)
  volume$=PeekS(@volume$)
  Left$=PeekS(@Left$) 
  Right$=PeekS(@Right$)
  If Val(Left$)<Val(volume$)
  Thismessage=(Val(volume$)-Val(Left$))*2
  EndIf
  If Val(Right$)<Val(volume$)
  Thismessage=(Val(Right$)-Val(volume$))*2
  EndIf
   ProcedureReturn Thismessage 
  EndProcedure
;} DeMp3GetBalance End

;{ DeMp3SetSpeed Start
ProcedureDLL DeMp3SetSpeed(TrackNum,Speed) ; Set the speed of the current music
Track$=Str(TrackNum)
If Speed=0
Speed=1
EndIf 
  sent=mciSendString_("set TrackNo:"+Track$+" Speed "+Str(Speed),NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3SetSpeed End

;{ DeMp3GetSpeed Start
ProcedureDLL DeMp3GetSpeed(TrackNum) ; Get the current speed of the music
Track$=Str(TrackNum) 
  Thismessage$=Space(32) 
  sent=mciSendString_("status TrackNo:"+Track$+" speed ",Thismessage$,32,NULL)
  Thismessage$=PeekS(@Thismessage$) 
  ProcedureReturn Val(Thismessage$) 
EndProcedure
;} DeMusicGetSpeed End

;{ DeMp3GetLength Start
ProcedureDLL.s DeMp3GetLength(TrackNum,Option); Opt's - 0=Raw ms, 1=hh:mm:ss, 2=hh:mm:ss:ms
  Track$=Str(TrackNum)
  Thismessage$=Space(32)
  sent=mciSendString_("status TrackNo:"+Track$+" length",Thismessage$,32,NULL)
  Thismessage$=PeekS(@Thismessage$) 
  If Option>0
  position=Val(Thismessage$)
  ms=position%1000
  position/1000
  sec=position % 60:position/60 
  min=position % 60:position/60
  If Option=1
  Time$=RSet(Str(position),2,"0")+":"+RSet(Str(min),2,"0")+":"+RSet(Str(sec),2,"0")
  EndIf
  If Option=2
  Time$=RSet(Str(position),2,"0")+":"+RSet(Str(min),2,"0")+":"+RSet(Str(sec),2,"0")+":"+RSet(Str(ms),3,"0")
  EndIf
  Else
  Time$=Thismessage$
  EndIf  
  ProcedureReturn Time$
EndProcedure
;} DeMp3GetLength End

;{ DeMp3GetPosition Start
ProcedureDLL.s DeMp3GetPosition(TrackNum,Option) ; Opt's - 0=Raw ms, 1=hh:mm:ss, 2=hh:mm:ss:ms
  Track$=Str(TrackNum)
  Thismessage$=Space(32)
  sent=mciSendString_("status TrackNo:"+Track$+" position",Thismessage$,32,NULL)
  Thismessage$=PeekS(@Thismessage$)
  If Option>0
  position=Val(Thismessage$)
  ms=position%1000:position/1000
  sec=position % 60:position/60 
  min=position % 60:position/60
  If Option=1
  Time$=RSet(Str(position),2,"0")+":"+RSet(Str(min),2,"0")+":"+RSet(Str(sec),2,"0")
  EndIf
  If Option=2
  Time$=RSet(Str(position),2,"0")+":"+RSet(Str(min),2,"0")+":"+RSet(Str(sec),2,"0")+":"+RSet(Str(ms),3,"0")
  EndIf
  Else
  Time$=Thismessage$
  EndIf
  ProcedureReturn Time$ 
EndProcedure
;} DeMp3GetPosition End

;{ DeMp3SetPosition
ProcedureDLL DeMp3SetPosition(TrackNum,pos) ; Find the current position in the music file
  Track$=Str(TrackNum) 
  sent=mciSendString_("Seek TrackNo:"+Track$+" to "+Str(pos),NULL,NULL,NULL) 
  ProcedureReturn sent 
EndProcedure
;} DeMp3Setposition End

;{ DeMp3Repeat Start
 ProcedureDLL DeMp3Repeat(TrackNum) ; Repeat the currently playing music
   Track$=Str(TrackNum)
   sent=mciSendString_("play TrackNo:"+Track$+" repeat",NULL,NULL,NULL)
   ProcedureReturn sent
   EndProcedure
;} DeMp3Repeat End
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 1
; Folding = -------
;       EnableNT4